<script setup>
import TechnologicCardCreate from '@/components/technologic_card/TechnologicCardCreate.vue'
import TechnologicCardBrowse from '@/components/technologic_card/TechnologicCardBrowse.vue'
</script>

<template>
<div>
  <div>
    <div v-if="$store.state.user?.is_superuser" class="main_buttons">
        <button type="button" @click='state="browse"'>Browse</button>
        <button type="button" @click='state="add_new"'>Add new</button>
    </div>

    <TechnologicCardCreate v-if='state=="add_new" && $store.state.user?.is_superuser' />
    <TechnologicCardCreate :initial_object=record :after_post_callback='afterPostCallback' v-else-if='state=="edit" && $store.state.user?.is_superuser' />
    <TechnologicCardBrowse :after_edit='afterChildButtonEdit' v-else-if='state=="browse"' />
  </div>

  </div>
</template>

<script>
import { setAuthorizationToken } from "../utils/authUtils";
import { getTechnologicCardById } from "../utils/apiUtils";

export default {
  name: "TechnologicCard",
  props: {
    id : String,
    inital_state : String
  },
  data: function() {
    return {
      record: null,
      state: "browse"
    };
  },
  methods: {
    afterPostCallback() {
      this.state = "browse";
    },
    afterChildButtonEdit(id) {
      if (id) {
        (async () => {
            setAuthorizationToken(localStorage.getItem("jwtAccessToken"));
            this.record = await getTechnologicCardById(id)
            this.state = "edit"
        })();
      }
    }
  },
  mounted: function() {}
};
</script>

<style scoped>

</style>>